# Folder by Easy CLI Utility :open_file_folder:

A Dart CLI tool that generates the folder structure for the folder-by-feature pattern. This tool helps to reduce the repetitive work required to setup directories for models, services, repositories, screens and widgets.

## Required flutter packages
> Get,
> Get Storage,
> Dio,
> Intl Phone Field

The folder structure generated by the cli is as follows:

```md
core/
┣ constants/
┃ ┣ app_icon.dart
┃ ┣ app_icon.svg.dart
┃ ┗ app_regex.dart
┣ init/
┃ ┣ service/
┃ ┃ ┣ base_service.dart
┃ ┃ ┗ dio_service.dart
┃ ┣ view
┃ ┃ ┣ base
┃ ┃ ┃ ┣ base_state.dart
┃ ┃ ┃ ┗ base_stateless.dart
┃ ┃ ┣ theme
┃ ┃ ┃ ┗ theme.dart
┃ ┃ ┣ widget
┃ ┃ ┃ ┣ button
┃ ┃ ┃ ┣ card
┃ ┃ ┃ ┣ checkbox
┃ ┃ ┃ ┣ form
┃ ┃ ┃ ┣ slider
┃ ┃ ┃ ┣ textformfield
┃ ┣ viewmodel
┃ ┃ ┗ base_viewmodel.dart
┣ manager/
┃ ┣ auth/
┣ ┣ auth_manager.dart
┃ ┃
┃ ┣ cache/
┣ ┗ cache_manager.dart       
┣ extension/
┃ ┗ base_extension.dart 
┣ language/
┃ ┗ base_language.dart 
┣ model/
┗ ┗ base_model.dart 

feature/
┣ components/
┃ ┗ button

product/
┣ model/
┃ ┗ product_model.dart
┣ service/
┃ ┗ product_service.dart
┣ view/
┣ ┣ product_state_view.dart
┣ ┗ product_stateless_view.dart       
┣ viewmodel/
┃ ┗ product_viewmodel.dart 
```

## Command Usage :wrench:
> Make sure you are in the root of your project
```sh
easy generate -n <project_name>
```

:copyright: 2022 Eren KARA